local L = LibStub("AceLocale-3.0"):GetLocale("SDA")
local SDA = CreateFrame("Frame")
SDA:Hide()

local function ExpireWarning(self)
	local msg = string.format(L["{Skull} %s out in 2, next person get ready! {Skull}"], SDA.drum);
	SendChatMessage(msg, "PARTY")
	SendChatMessage(msg, "PARTY")
end

local nextUpdate = 0

local function OnUpdate(self, elapsed)
	nextUpdate = nextUpdate - elapsed

	if nextUpdate < 0 then
		if self.endtime and GetTime() > self.endtime then
			self.endtime = nil
			ExpireWarning()
			self:Hide()
		end
		nextUpdate = 0.2
	end
end

local function OnEvent(self, event, unit, spell)
	if not UnitInParty("party1") then return end
	if unit == "player" then
		if spell == L["Drums of Battle"] then
			SendChatMessage(L["{circle} Drums of Battle used {circle}"], "PARTY")
			SendChatMessage(L["{circle} Drums of Battle used {circle}"], "PARTY")
			self.endtime = GetTime() + 28
		elseif spell == L["Drums of War"] then
			SendChatMessage(L["{star} Drums of War used {star}"], "PARTY")
			SendChatMessage(L["{star} Drums of War used {star}"], "PARTY")
			self.endtime = GetTime() + 28
		elseif spell == L["Drums of Restoration"] then
			SendChatMessage(L["{triangle} Drums of Restoration used {triangle}"], "PARTY")
			SendChatMessage(L["{triangle} Drums of Restoration used {triangle}"], "PARTY")
			self.endtime = GetTime() + 13
		elseif spell == L["Drums of Speed"] then
			SendChatMessage(L["{diamond} Drums of Speed used {diamond}"], "PARTY")
			SendChatMessage(L["{diamond} Drums of Speed used {diamond}"], "PARTY")
			self.endtime = GetTime() + 28
		else
			return
		end

		self.drum = spell
		self:Show()
	end
end

SDA:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
SDA:SetScript("OnEvent", OnEvent)
SDA:SetScript("OnUpdate", OnUpdate)
